function [Fq, RHS] = drvr(Body, Joint, q, dq, t, flag)
% function [Fq, RHS] = drvr(Body, Joint, q, dq, t, flag)
% 
% 쓮S̕]
% 
% ̐F
%  flag==1: Constraint equation
%  flag==2: Right-hand-side of velocity equations
%  flag==3: Right-hand-side of acceleration equations
% 
% Copyright (C) 2007  Ms, ]䕔 , ŗt  All Rights Reserved.

% FqRHS̃TCY錾
Fq  = zeros(Joint.DR.Number, 3*Body.Number);
RHS = zeros(Joint.DR.Number, 1);

for k=1:Joint.DR.Number
	
	i = Joint.DR.Data(k,1);
	n = Joint.DR.Data(k,2);
	
	% Jacobian matrix nonzero entry
	Fq(k,3*(i-1)+n)= 1;
	
	% Constraint equation
	if flag==1
		RHS(k)= q(i,n) - Joint.DR.Data(k,3) - Joint.DR.Data(k,4)*t + Joint.DR.Data(k,5)*t^2/2.0;
	end
	
	% Right-hand-side of velocity equation
	if flag==2
		RHS(k)= Joint.DR.Data(k,4) + t*Joint.DR.Data(k,5);
	end
	
	% Right-hand-side of acceleration equation
	if flag==3
		RHS(k)= Joint.DR.Data(k,5);
	end
end

% =================================================================================
% vO̎gp
% 1. {vOуf[^pŁCЕzĂ͂ȂȂD
% 2. {vOуf[^𒘍҂̋ȂcړIŗpĂ͂ȂȂD
% 3. {vOуf[^̉ς́CcړIłȂ莩RłD
% 4. {vOуf[^gp邱Ƃɂ萶QȂǂɂẮCҁC
%    vNҁC(){@BwC()RiЂ͈؂̐ӔC𕉂ȂD
% 5. {vO̒쌠́C{Ғ҂ȂтɃvO҂ɋAD
% =================================================================================